﻿using ShapeDemo.Interface;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ShapeDemo
{
    class Program
    {       
        static void Main(string[] args)
        {
            IEnumerable<IRegularPolygon> shapes = ExtractShapes();
            foreach (IRegularPolygon shape in shapes)
            {
                Console.WriteLine("Area: " + shape.GetArea());
            }

            Console.ReadKey();
        }

        private static IEnumerable<IRegularPolygon> ExtractShapes()
        {
            // Read from external sources and return the polygons
            // parsing the file and extract the shapes

            return new IRegularPolygon[] {
                new Sequare(3), 
                new Triangle(4),
                new Sequare(5)
            };
        }

        private static IRegularPolygon[] ExtractShapesOld()
        {
            // Read from external sources and return the polygons
            // parsing the file and extract the shapes

            return new IRegularPolygon[] {
                new Sequare(3), 
                new Triangle(4),
                new Sequare(5)
            };
        }

        private static void SequareDemo()
        {
            // Sequare
            int numberOfSides = 4;

            // Calculate Area
            Console.Write("Enter Side Length: ");
            int sideLength = int.Parse(Console.ReadLine());
            double area = sideLength * sideLength;
            Console.WriteLine("Area: " + area);

            // Calculate Perimeter
            double permieter = numberOfSides * sideLength;
            Console.WriteLine("Permieter: " + permieter);
        }

        private static void TriangleDemo()
        {
            // Triangle
            int numberOfSides = 3;

            // Calculate Area
            Console.Write("Enter Side Length: ");
            int sideLength = int.Parse(Console.ReadLine());
            double area = sideLength * sideLength * Math.Sqrt(3) / 4;
            Console.WriteLine("Area: " + area);

            // Calculate Perimeter
            double permieter = numberOfSides * sideLength;
            Console.WriteLine("Permieter: " + permieter);
        }
    }
}
