﻿using Products.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Products.Repository
{
    public class ProductRepository: IProductRepository
    {
        IList<Model.Product> IProductRepository.FindAll()
        {
            var products = from p in new ProductsDataContext().Products
                           select new Model.Product
                           {
                               Id = p.Id,
                               Name = p.Name,
                               Price = new Model.Price(p.RRP, p.SellingPrice)
                           };
            return products.ToList();
        }

        // this used only for procedure code!
        public IList<Product> GetProducts()
        {
            return new ProductsDataContext().Products.ToList();            
        }
    }
}
