﻿using Products.Model;
using Products.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProductsDemo
{
    class ProcedureWay
    {
        static void TheCode()
        {
            var products = GetProducts();

            Console.Write("Enter Customer Type: ");
            int customerType = int.Parse(Console.ReadLine());

            foreach (var product in products)
            {
                decimal newSellingPrice = ApplyDiscount(product.SellingPrice, customerType);

                string discount = DisplayDiscount(product.RRP, newSellingPrice);
                string saving = DisplaySavings(product.RRP, newSellingPrice);

                Console.WriteLine(String.Format("Name: {0} \nPrice: {1:C} \nRRP: {2:C} " +
                            "\nDiscount: {3} \nSaving: {4}\n",
                        product.Name, newSellingPrice, product.RRP, discount, saving));
            }

            Console.ReadKey();
        }

        private static decimal ApplyDiscount(decimal originalPrice, int customerType)
        {
            decimal price = originalPrice;

            if (customerType == 1)
            {
                price = price * 0.95M;
            }

            return price;
        }

        private static IList<Products.Repository.Product> GetProducts()
        {
            ProductRepository repo = new ProductRepository();
            return repo.GetProducts();
        }


        private static string DisplayDiscount(decimal RRP, decimal SalePrice)
        {
            string discountText = "";
            if (RRP > SalePrice)
                discountText = string.Format("{0:C}", (RRP - SalePrice));
            return discountText;
        }

        private static string DisplaySavings(decimal RRP, decimal SalePrice)
        {
            string savingText = "";
            if (RRP > SalePrice)
                savingText = (1 - (SalePrice / RRP)).ToString("#%");
            return savingText;
        }

    }
}
