﻿using Products.Model;
using Products.Presentation;
using Products.Repository;
using Products.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProductsDemo
{
    class Program
    {
        private static ProductListPresenter _presenter;

        static void Main(string[] args)
        {
            ConsoleUI console = new ConsoleUI();

            _presenter = new ProductListPresenter(console,
                new Products.Service.ProductService(
                    new Products.Model.ProductService(
                        new ProductRepository())));

            _presenter.Display();

            Console.ReadKey();
        }

        class ConsoleUI : IProductListView
        {
            public void Display(IList<ProductViewModel> Products)
            {
                foreach (ProductViewModel product in Products)
                {
                    Console.WriteLine(String.Format("Name: {0} \nPrice: {1:C} \nRRP: {2:C} " +
                        "\nDiscount: {3} \nSaving: {4}\n",
                      product.Name, product.SellingPrice, product.RRP, product.Discount, product.Savings));
                }
            }

            public CustomerType CustomerType
            {
                get
                { return (CustomerType)Enum.ToObject(typeof(CustomerType), int.Parse(Console.ReadLine())); }
            }

            public string ErrorMessage
            {
                set
                { Console.WriteLine(String.Format("Error: {0}\n", value)); }
            }
        }
    }
}
